commit 36de56d3d643e7b8131fa6671b9e85258a1d1ca1
Author: Marek Polacek <polacek@redhat.com>
Date:   Thu Aug 29 10:40:50 2024 -0400

    c++: ICE with -Wtautological-compare in template [PR116534]
    
    Pre r14-4793, we'd call warn_tautological_cmp -> operand_equal_p
    with operands wrapped in NON_DEPENDENT_EXPR, which works, since
    o_e_p bails for codes it doesn't know.  But now we pass operands
    not encapsulated in NON_DEPENDENT_EXPR, and crash, because the
    template tree for &a[x] has null DECL_FIELD_OFFSET.
    
    This patch extends r12-7797 to cover the case when DECL_FIELD_OFFSET
    is null.
    
            PR c++/116534
    
    gcc/ChangeLog:
    
            * fold-const.cc (operand_compare::operand_equal_p): If either
            field's DECL_FIELD_OFFSET is null, compare the fields with ==.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/warn/Wtautological-compare4.C: New test.
    
    Reviewed-by: Jason Merrill <jason@redhat.com>
    (cherry picked from commit 7ca486889b1b1c7e7bcbbca3b6caa103294ec07d)

diff --git a/gcc/fold-const.cc b/gcc/fold-const.cc
index 869f6363560..1e6b573ca01 100644
--- a/gcc/fold-const.cc
+++ b/gcc/fold-const.cc
@@ -3578,9 +3578,15 @@ operand_compare::operand_equal_p (const_tree arg0, const_tree arg1,
 
 		    /* Non-FIELD_DECL operands can appear in C++ templates.  */
 		    if (TREE_CODE (field0) != FIELD_DECL
-			|| TREE_CODE (field1) != FIELD_DECL
-			|| !operand_equal_p (DECL_FIELD_OFFSET (field0),
-					     DECL_FIELD_OFFSET (field1), flags)
+			|| TREE_CODE (field1) != FIELD_DECL)
+		      return false;
+
+		    if (!DECL_FIELD_OFFSET (field0)
+			|| !DECL_FIELD_OFFSET (field1))
+		      return field0 == field1;
+
+		    if (!operand_equal_p (DECL_FIELD_OFFSET (field0),
+					  DECL_FIELD_OFFSET (field1), flags)
 			|| !operand_equal_p (DECL_FIELD_BIT_OFFSET (field0),
 					     DECL_FIELD_BIT_OFFSET (field1),
 					     flags))
diff --git a/gcc/testsuite/g++.dg/warn/Wtautological-compare4.C b/gcc/testsuite/g++.dg/warn/Wtautological-compare4.C
new file mode 100644
index 00000000000..96308f49a42
--- /dev/null
+++ b/gcc/testsuite/g++.dg/warn/Wtautological-compare4.C
@@ -0,0 +1,21 @@
+// PR c++/116534
+// { dg-do compile }
+// { dg-options "-Wall" }
+
+template <class A>
+struct Test {
+    bool foo(unsigned x, unsigned y) {
+        bool test = &a[x] == &b[y];
+	return test;
+    }
+    unsigned *a;
+    unsigned *b;
+};
+
+void
+g ()
+{
+  Test<int> t;
+  t.foo (0u, 1u);
+  t.foo (0u, 0u);
+}

